// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Quality contains data that describe the quality of the data from the server. Quality of the data
 * is also related to the mode of a logical node. Further details can be found in IEC 61850-7-4. The
 * different quality attributes are &lt;i&gt;not&lt;/i&gt; independent.The default value shall be applied if the
 * functionality of the related attribute is not supported. The mapping may specify to exclude the
 * attribute from the message if it is not supported or if the default value applies.
 * </pre>
 *
 * Protobuf type {@code commonmodule.Quality}
 */
public final class Quality extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.Quality)
    QualityOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Quality.newBuilder() to construct.
  private Quality(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Quality() {
    source_ = 0;
    validity_ = 0;
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new Quality();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Quality_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Quality_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.Quality.class, openfmb.commonmodule.Quality.Builder.class);
  }

  public static final int DETAILQUAL_FIELD_NUMBER = 1;
  private openfmb.commonmodule.DetailQual detailQual_;
  /**
   * <pre>
   * Describes some reasons in case 'validity' is not 'good'.
   * </pre>
   *
   * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the detailQual field is set.
   */
  @java.lang.Override
  public boolean hasDetailQual() {
    return detailQual_ != null;
  }
  /**
   * <pre>
   * Describes some reasons in case 'validity' is not 'good'.
   * </pre>
   *
   * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The detailQual.
   */
  @java.lang.Override
  public openfmb.commonmodule.DetailQual getDetailQual() {
    return detailQual_ == null ? openfmb.commonmodule.DetailQual.getDefaultInstance() : detailQual_;
  }
  /**
   * <pre>
   * Describes some reasons in case 'validity' is not 'good'.
   * </pre>
   *
   * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.DetailQualOrBuilder getDetailQualOrBuilder() {
    return detailQual_ == null ? openfmb.commonmodule.DetailQual.getDefaultInstance() : detailQual_;
  }

  public static final int OPERATORBLOCKED_FIELD_NUMBER = 2;
  private boolean operatorBlocked_ = false;
  /**
   * <pre>
   * (default=false) If true, further update of the value has been blocked by an operator. The value
   * shall be the information that was acquired before blocking. If this flag is set, then the
   * 'detailQual.oldData' shall also be set. The operator shall use the data attribute 'CDC.blkEna' to
   * block the update of the value. NOTE Both an operator as well as an automatic function may freeze
   * communication updating as well as input updating. In both cases, 'detailQual.oldData' will be set.
   * If the blocking is done by an operator, then this flag is set additionally, and an operator activity
   * is required to clear the condition.
   * </pre>
   *
   * <code>bool operatorBlocked = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The operatorBlocked.
   */
  @java.lang.Override
  public boolean getOperatorBlocked() {
    return operatorBlocked_;
  }

  public static final int SOURCE_FIELD_NUMBER = 3;
  private int source_ = 0;
  /**
   * <pre>
   * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
   * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
   * There are various means to clear a substitution. As an example, a substitution that was done
   * following an invalid condition may be cleared automatically if the invalid condition is cleared.
   * However, this is a local issue and therefore not within the scope of this standard.
   * </pre>
   *
   * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The enum numeric value on the wire for source.
   */
  @java.lang.Override public int getSourceValue() {
    return source_;
  }
  /**
   * <pre>
   * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
   * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
   * There are various means to clear a substitution. As an example, a substitution that was done
   * following an invalid condition may be cleared automatically if the invalid condition is cleared.
   * However, this is a local issue and therefore not within the scope of this standard.
   * </pre>
   *
   * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The source.
   */
  @java.lang.Override public openfmb.commonmodule.SourceKind getSource() {
    openfmb.commonmodule.SourceKind result = openfmb.commonmodule.SourceKind.forNumber(source_);
    return result == null ? openfmb.commonmodule.SourceKind.UNRECOGNIZED : result;
  }

  public static final int TEST_FIELD_NUMBER = 4;
  private boolean test_ = false;
  /**
   * <pre>
   * (default=false) If true, the value is a test value. The processing of the test quality in the
   * client shall be as described in IEC 61850-7-4. This bit shall be completely independent from the
   * other bits within the quality descriptor.
   * </pre>
   *
   * <code>bool test = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The test.
   */
  @java.lang.Override
  public boolean getTest() {
    return test_;
  }

  public static final int VALIDITY_FIELD_NUMBER = 5;
  private int validity_ = 0;
  /**
   * <pre>
   * Validity of the value, as condensed information for the client. In case this value is not
   * 'good', some reasons may be found in the 'detailQual'.
   * </pre>
   *
   * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The enum numeric value on the wire for validity.
   */
  @java.lang.Override public int getValidityValue() {
    return validity_;
  }
  /**
   * <pre>
   * Validity of the value, as condensed information for the client. In case this value is not
   * 'good', some reasons may be found in the 'detailQual'.
   * </pre>
   *
   * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The validity.
   */
  @java.lang.Override public openfmb.commonmodule.ValidityKind getValidity() {
    openfmb.commonmodule.ValidityKind result = openfmb.commonmodule.ValidityKind.forNumber(validity_);
    return result == null ? openfmb.commonmodule.ValidityKind.UNRECOGNIZED : result;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (detailQual_ != null) {
      output.writeMessage(1, getDetailQual());
    }
    if (operatorBlocked_ != false) {
      output.writeBool(2, operatorBlocked_);
    }
    if (source_ != openfmb.commonmodule.SourceKind.SourceKind_UNDEFINED.getNumber()) {
      output.writeEnum(3, source_);
    }
    if (test_ != false) {
      output.writeBool(4, test_);
    }
    if (validity_ != openfmb.commonmodule.ValidityKind.ValidityKind_UNDEFINED.getNumber()) {
      output.writeEnum(5, validity_);
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (detailQual_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getDetailQual());
    }
    if (operatorBlocked_ != false) {
      size += com.google.protobuf.CodedOutputStream
        .computeBoolSize(2, operatorBlocked_);
    }
    if (source_ != openfmb.commonmodule.SourceKind.SourceKind_UNDEFINED.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(3, source_);
    }
    if (test_ != false) {
      size += com.google.protobuf.CodedOutputStream
        .computeBoolSize(4, test_);
    }
    if (validity_ != openfmb.commonmodule.ValidityKind.ValidityKind_UNDEFINED.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(5, validity_);
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.Quality)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.Quality other = (openfmb.commonmodule.Quality) obj;

    if (hasDetailQual() != other.hasDetailQual()) return false;
    if (hasDetailQual()) {
      if (!getDetailQual()
          .equals(other.getDetailQual())) return false;
    }
    if (getOperatorBlocked()
        != other.getOperatorBlocked()) return false;
    if (source_ != other.source_) return false;
    if (getTest()
        != other.getTest()) return false;
    if (validity_ != other.validity_) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasDetailQual()) {
      hash = (37 * hash) + DETAILQUAL_FIELD_NUMBER;
      hash = (53 * hash) + getDetailQual().hashCode();
    }
    hash = (37 * hash) + OPERATORBLOCKED_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashBoolean(
        getOperatorBlocked());
    hash = (37 * hash) + SOURCE_FIELD_NUMBER;
    hash = (53 * hash) + source_;
    hash = (37 * hash) + TEST_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashBoolean(
        getTest());
    hash = (37 * hash) + VALIDITY_FIELD_NUMBER;
    hash = (53 * hash) + validity_;
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.Quality parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Quality parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Quality parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Quality parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Quality parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Quality parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Quality parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Quality parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.Quality parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Quality parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.Quality parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Quality parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.Quality prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Quality contains data that describe the quality of the data from the server. Quality of the data
   * is also related to the mode of a logical node. Further details can be found in IEC 61850-7-4. The
   * different quality attributes are &lt;i&gt;not&lt;/i&gt; independent.The default value shall be applied if the
   * functionality of the related attribute is not supported. The mapping may specify to exclude the
   * attribute from the message if it is not supported or if the default value applies.
   * </pre>
   *
   * Protobuf type {@code commonmodule.Quality}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.Quality)
      openfmb.commonmodule.QualityOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Quality_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Quality_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.Quality.class, openfmb.commonmodule.Quality.Builder.class);
    }

    // Construct using openfmb.commonmodule.Quality.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      detailQual_ = null;
      if (detailQualBuilder_ != null) {
        detailQualBuilder_.dispose();
        detailQualBuilder_ = null;
      }
      operatorBlocked_ = false;
      source_ = 0;
      test_ = false;
      validity_ = 0;
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Quality_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.Quality getDefaultInstanceForType() {
      return openfmb.commonmodule.Quality.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.Quality build() {
      openfmb.commonmodule.Quality result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.Quality buildPartial() {
      openfmb.commonmodule.Quality result = new openfmb.commonmodule.Quality(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.Quality result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.detailQual_ = detailQualBuilder_ == null
            ? detailQual_
            : detailQualBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.operatorBlocked_ = operatorBlocked_;
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.source_ = source_;
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.test_ = test_;
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.validity_ = validity_;
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.Quality) {
        return mergeFrom((openfmb.commonmodule.Quality)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.Quality other) {
      if (other == openfmb.commonmodule.Quality.getDefaultInstance()) return this;
      if (other.hasDetailQual()) {
        mergeDetailQual(other.getDetailQual());
      }
      if (other.getOperatorBlocked() != false) {
        setOperatorBlocked(other.getOperatorBlocked());
      }
      if (other.source_ != 0) {
        setSourceValue(other.getSourceValue());
      }
      if (other.getTest() != false) {
        setTest(other.getTest());
      }
      if (other.validity_ != 0) {
        setValidityValue(other.getValidityValue());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getDetailQualFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 16: {
              operatorBlocked_ = input.readBool();
              bitField0_ |= 0x00000002;
              break;
            } // case 16
            case 24: {
              source_ = input.readEnum();
              bitField0_ |= 0x00000004;
              break;
            } // case 24
            case 32: {
              test_ = input.readBool();
              bitField0_ |= 0x00000008;
              break;
            } // case 32
            case 40: {
              validity_ = input.readEnum();
              bitField0_ |= 0x00000010;
              break;
            } // case 40
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.DetailQual detailQual_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.DetailQual, openfmb.commonmodule.DetailQual.Builder, openfmb.commonmodule.DetailQualOrBuilder> detailQualBuilder_;
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the detailQual field is set.
     */
    public boolean hasDetailQual() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The detailQual.
     */
    public openfmb.commonmodule.DetailQual getDetailQual() {
      if (detailQualBuilder_ == null) {
        return detailQual_ == null ? openfmb.commonmodule.DetailQual.getDefaultInstance() : detailQual_;
      } else {
        return detailQualBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setDetailQual(openfmb.commonmodule.DetailQual value) {
      if (detailQualBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        detailQual_ = value;
      } else {
        detailQualBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setDetailQual(
        openfmb.commonmodule.DetailQual.Builder builderForValue) {
      if (detailQualBuilder_ == null) {
        detailQual_ = builderForValue.build();
      } else {
        detailQualBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeDetailQual(openfmb.commonmodule.DetailQual value) {
      if (detailQualBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          detailQual_ != null &&
          detailQual_ != openfmb.commonmodule.DetailQual.getDefaultInstance()) {
          getDetailQualBuilder().mergeFrom(value);
        } else {
          detailQual_ = value;
        }
      } else {
        detailQualBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearDetailQual() {
      bitField0_ = (bitField0_ & ~0x00000001);
      detailQual_ = null;
      if (detailQualBuilder_ != null) {
        detailQualBuilder_.dispose();
        detailQualBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.DetailQual.Builder getDetailQualBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getDetailQualFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.DetailQualOrBuilder getDetailQualOrBuilder() {
      if (detailQualBuilder_ != null) {
        return detailQualBuilder_.getMessageOrBuilder();
      } else {
        return detailQual_ == null ?
            openfmb.commonmodule.DetailQual.getDefaultInstance() : detailQual_;
      }
    }
    /**
     * <pre>
     * Describes some reasons in case 'validity' is not 'good'.
     * </pre>
     *
     * <code>.commonmodule.DetailQual detailQual = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.DetailQual, openfmb.commonmodule.DetailQual.Builder, openfmb.commonmodule.DetailQualOrBuilder> 
        getDetailQualFieldBuilder() {
      if (detailQualBuilder_ == null) {
        detailQualBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.DetailQual, openfmb.commonmodule.DetailQual.Builder, openfmb.commonmodule.DetailQualOrBuilder>(
                getDetailQual(),
                getParentForChildren(),
                isClean());
        detailQual_ = null;
      }
      return detailQualBuilder_;
    }

    private boolean operatorBlocked_ ;
    /**
     * <pre>
     * (default=false) If true, further update of the value has been blocked by an operator. The value
     * shall be the information that was acquired before blocking. If this flag is set, then the
     * 'detailQual.oldData' shall also be set. The operator shall use the data attribute 'CDC.blkEna' to
     * block the update of the value. NOTE Both an operator as well as an automatic function may freeze
     * communication updating as well as input updating. In both cases, 'detailQual.oldData' will be set.
     * If the blocking is done by an operator, then this flag is set additionally, and an operator activity
     * is required to clear the condition.
     * </pre>
     *
     * <code>bool operatorBlocked = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The operatorBlocked.
     */
    @java.lang.Override
    public boolean getOperatorBlocked() {
      return operatorBlocked_;
    }
    /**
     * <pre>
     * (default=false) If true, further update of the value has been blocked by an operator. The value
     * shall be the information that was acquired before blocking. If this flag is set, then the
     * 'detailQual.oldData' shall also be set. The operator shall use the data attribute 'CDC.blkEna' to
     * block the update of the value. NOTE Both an operator as well as an automatic function may freeze
     * communication updating as well as input updating. In both cases, 'detailQual.oldData' will be set.
     * If the blocking is done by an operator, then this flag is set additionally, and an operator activity
     * is required to clear the condition.
     * </pre>
     *
     * <code>bool operatorBlocked = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The operatorBlocked to set.
     * @return This builder for chaining.
     */
    public Builder setOperatorBlocked(boolean value) {

      operatorBlocked_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (default=false) If true, further update of the value has been blocked by an operator. The value
     * shall be the information that was acquired before blocking. If this flag is set, then the
     * 'detailQual.oldData' shall also be set. The operator shall use the data attribute 'CDC.blkEna' to
     * block the update of the value. NOTE Both an operator as well as an automatic function may freeze
     * communication updating as well as input updating. In both cases, 'detailQual.oldData' will be set.
     * If the blocking is done by an operator, then this flag is set additionally, and an operator activity
     * is required to clear the condition.
     * </pre>
     *
     * <code>bool operatorBlocked = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearOperatorBlocked() {
      bitField0_ = (bitField0_ & ~0x00000002);
      operatorBlocked_ = false;
      onChanged();
      return this;
    }

    private int source_ = 0;
    /**
     * <pre>
     * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
     * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
     * There are various means to clear a substitution. As an example, a substitution that was done
     * following an invalid condition may be cleared automatically if the invalid condition is cleared.
     * However, this is a local issue and therefore not within the scope of this standard.
     * </pre>
     *
     * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The enum numeric value on the wire for source.
     */
    @java.lang.Override public int getSourceValue() {
      return source_;
    }
    /**
     * <pre>
     * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
     * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
     * There are various means to clear a substitution. As an example, a substitution that was done
     * following an invalid condition may be cleared automatically if the invalid condition is cleared.
     * However, this is a local issue and therefore not within the scope of this standard.
     * </pre>
     *
     * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The enum numeric value on the wire for source to set.
     * @return This builder for chaining.
     */
    public Builder setSourceValue(int value) {
      source_ = value;
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
     * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
     * There are various means to clear a substitution. As an example, a substitution that was done
     * following an invalid condition may be cleared automatically if the invalid condition is cleared.
     * However, this is a local issue and therefore not within the scope of this standard.
     * </pre>
     *
     * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The source.
     */
    @java.lang.Override
    public openfmb.commonmodule.SourceKind getSource() {
      openfmb.commonmodule.SourceKind result = openfmb.commonmodule.SourceKind.forNumber(source_);
      return result == null ? openfmb.commonmodule.SourceKind.UNRECOGNIZED : result;
    }
    /**
     * <pre>
     * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
     * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
     * There are various means to clear a substitution. As an example, a substitution that was done
     * following an invalid condition may be cleared automatically if the invalid condition is cleared.
     * However, this is a local issue and therefore not within the scope of this standard.
     * </pre>
     *
     * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The source to set.
     * @return This builder for chaining.
     */
    public Builder setSource(openfmb.commonmodule.SourceKind value) {
      if (value == null) {
        throw new NullPointerException();
      }
      bitField0_ |= 0x00000004;
      source_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (default=process) Defines the source of a value. NOTE 1 Substitution may be done locally or via
     * the communication services. In the second case, specific attributes with a FC=SV are used. NOTE 2
     * There are various means to clear a substitution. As an example, a substitution that was done
     * following an invalid condition may be cleared automatically if the invalid condition is cleared.
     * However, this is a local issue and therefore not within the scope of this standard.
     * </pre>
     *
     * <code>.commonmodule.SourceKind source = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearSource() {
      bitField0_ = (bitField0_ & ~0x00000004);
      source_ = 0;
      onChanged();
      return this;
    }

    private boolean test_ ;
    /**
     * <pre>
     * (default=false) If true, the value is a test value. The processing of the test quality in the
     * client shall be as described in IEC 61850-7-4. This bit shall be completely independent from the
     * other bits within the quality descriptor.
     * </pre>
     *
     * <code>bool test = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The test.
     */
    @java.lang.Override
    public boolean getTest() {
      return test_;
    }
    /**
     * <pre>
     * (default=false) If true, the value is a test value. The processing of the test quality in the
     * client shall be as described in IEC 61850-7-4. This bit shall be completely independent from the
     * other bits within the quality descriptor.
     * </pre>
     *
     * <code>bool test = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The test to set.
     * @return This builder for chaining.
     */
    public Builder setTest(boolean value) {

      test_ = value;
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (default=false) If true, the value is a test value. The processing of the test quality in the
     * client shall be as described in IEC 61850-7-4. This bit shall be completely independent from the
     * other bits within the quality descriptor.
     * </pre>
     *
     * <code>bool test = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearTest() {
      bitField0_ = (bitField0_ & ~0x00000008);
      test_ = false;
      onChanged();
      return this;
    }

    private int validity_ = 0;
    /**
     * <pre>
     * Validity of the value, as condensed information for the client. In case this value is not
     * 'good', some reasons may be found in the 'detailQual'.
     * </pre>
     *
     * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The enum numeric value on the wire for validity.
     */
    @java.lang.Override public int getValidityValue() {
      return validity_;
    }
    /**
     * <pre>
     * Validity of the value, as condensed information for the client. In case this value is not
     * 'good', some reasons may be found in the 'detailQual'.
     * </pre>
     *
     * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The enum numeric value on the wire for validity to set.
     * @return This builder for chaining.
     */
    public Builder setValidityValue(int value) {
      validity_ = value;
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Validity of the value, as condensed information for the client. In case this value is not
     * 'good', some reasons may be found in the 'detailQual'.
     * </pre>
     *
     * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The validity.
     */
    @java.lang.Override
    public openfmb.commonmodule.ValidityKind getValidity() {
      openfmb.commonmodule.ValidityKind result = openfmb.commonmodule.ValidityKind.forNumber(validity_);
      return result == null ? openfmb.commonmodule.ValidityKind.UNRECOGNIZED : result;
    }
    /**
     * <pre>
     * Validity of the value, as condensed information for the client. In case this value is not
     * 'good', some reasons may be found in the 'detailQual'.
     * </pre>
     *
     * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The validity to set.
     * @return This builder for chaining.
     */
    public Builder setValidity(openfmb.commonmodule.ValidityKind value) {
      if (value == null) {
        throw new NullPointerException();
      }
      bitField0_ |= 0x00000010;
      validity_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Validity of the value, as condensed information for the client. In case this value is not
     * 'good', some reasons may be found in the 'detailQual'.
     * </pre>
     *
     * <code>.commonmodule.ValidityKind validity = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearValidity() {
      bitField0_ = (bitField0_ & ~0x00000010);
      validity_ = 0;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.Quality)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.Quality)
  private static final openfmb.commonmodule.Quality DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.Quality();
  }

  public static openfmb.commonmodule.Quality getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Quality>
      PARSER = new com.google.protobuf.AbstractParser<Quality>() {
    @java.lang.Override
    public Quality parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<Quality> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Quality> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.Quality getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

